#include "ti86.inc"

.org _asm_exec_ram

 call ssetup
 ld hl,format 
 rst 20h     ;move ten to op1
progloop:
 xor a
 call _FindAlphaUp
 jr c,getkey
 call _check_asm
 jr nz,progloop
 rst 10h
 ld a,(hl)
 cp $b7
 jr z,progloop
 jr dispprog
progloopd:
 xor a
 call _FindAlphaDn
 jr c,getkey
 call _check_asm
 jr nz,progloopd
 rst 10h
 ld a,(hl)
 cp $b7
 jr z,progloopd
 jr dispprog
dispprog:
 ld de,$0304
 ld (_curRow),de
 ld hl,_OP1+2
 call _puts
 ld de,$0C04
 ld (_curRow),de
 rst 10h
 call _ex_ahl_bde
 call _get_word_ahl
 ex de,hl
 ld de,15
 add hl,de
 xor a
 call _dispAHL
getkey:
 halt
 call _get_key
 cp K_EXIT
 jr z,exit
 cp K_ENTER
 jr z,run
 cp K_SECOND
 jr z,run
 cp K_RIGHT
 jp z,progloop
 cp K_LEFT
 jr z,progloopd
 cp K_PLUS
 jr z,upcontrast
 cp K_MINUS
 jr z,dncontrast
 cp K_CLEAR
 jr z,poweroff
 jr getkey
run:
 rst 10h
 call _ex_ahl_bde
 call _load_ram_ahl
 call Find_Libs 
 xor a
 ld (hl),a
 push hl
 call _exec_assembly
 pop hl
 ld a,$c9
 ld (hl),a
 call ssetup
 jr dispprog
poweroff:
 res 3,(iy+8)
 set 4,(iy+8)
 call _off
 jr getkey
exit:
 call _clrScrn
 call _homeup
 ret
upcontrast:
 ld a,($C008)
 cp 31
 jr z,getkey
 inc a
 ld ($C008),a
 out (2),a
 jr getkey
dncontrast:
 ld a,($C008)
 cp 1
 jp c,getkey
 dec a
 ld ($C008),a
 out (2),a
 jp getkey
ssetup:
 call _clrScrn
 call _homeup
 ld hl,title
 call _puts
 set 3,(IY+5)
 ld de,$0303
 ld (_curRow),de
 ld hl,program
 call _puts
 res 3,(IY+5)
 ret

Find_Libs
 inc hl
 inc hl
 inc hl
Find_LibMain
 ld a,(hl)
 cp $c9
 ret z 
 rst 20h
 rst 10h
 jr c,NOLIBS
 push hl
 call _ex_ahl_bde
 call _set_abs_src_addr
 call _load_ram_ahl
 inc hl
 ld b,1
 ld a,(hl)
 sub $80
 ld d,a
 inc hl
 ld a,(hl)
 ld e,a
 call _ex_ahl_bde
 call _set_abs_dest_addr
 rst 10h
 call _get_var_size
 ld b,0
 call _ex_ahl_bde
 call _set_mm_num_bytes
 call _mm_ldir
 pop hl
 inc hl
 jr Find_Libs

NOLIBS
 call _clrScrn
 call _homeup
 ld hl,No_Libs_Found
 call _getkey
 call ssetup
 jp progloopd

format:
.db $12,$01,$01
title:
.db "LibShell",0
program:
.db 4,"Name"
No_Libs_Found
.db "Missing library",0 